// ------------------------------------------------------------------------------------
// irr::core::array<S3DVertex2TCoords> wrappers
// NOTES:
// did not wrap the const version of getLast()
// ------------------------------------------------------------------------------------

extern "C" array<S3DVertex2TCoords>* IrrCore_Array_S3DVertex2TCoords_new()
{
	return new array<S3DVertex2TCoords>();
}

extern "C" array<S3DVertex2TCoords>* IrrCore_Array_S3DVertex2TCoords_newWithSize(u32 start_count)
{
	return new array<S3DVertex2TCoords>(start_count);
}

extern "C" array<S3DVertex2TCoords>* IrrCore_Array_S3DVertex2TCoords_newFromOther(array<S3DVertex2TCoords>* other)
{
	return new array<S3DVertex2TCoords>(*other);
}

extern "C" void IrrCore_Array_S3DVertex2TCoords_del(array<S3DVertex2TCoords>* arr)
{
	if (arr)
		delete arr;
		
	arr=0;
}

extern "C" u32 IrrCore_Array_S3DVertex2TCoords_allocated_size(array<S3DVertex2TCoords>* arr)
{
	if (arr)
		return arr->allocated_size();
	else
		return 0;
}

extern "C" void IrrCore_Array_S3DVertex2TCoords_clear(array<S3DVertex2TCoords>* arr)
{
	if (arr)
		arr->clear();
}

extern "C" const S3DVertex2TCoords* IrrCore_Array_S3DVertex2TCoords_const_pointer(array<S3DVertex2TCoords>* arr)
{
	if (arr)
		arr->const_pointer();
}

extern "C" S3DVertex2TCoords* IrrCore_Array_S3DVertex2TCoords_pointer(array<S3DVertex2TCoords>* arr)
{
	if (arr)
		arr->pointer();
}

extern "C" bool IrrCore_Array_S3DVertex2TCoords_empty(array<S3DVertex2TCoords>* arr)
{
	if (arr)
		return arr->empty();
	else
		return true;
}

extern "C" void IrrCore_Array_S3DVertex2TCoords_eraseWithCount(array<S3DVertex2TCoords>* arr,u32 idx,s32 count)
{
	if (arr)
		arr->erase(idx,count);
}

extern "C" void IrrCore_Array_S3DVertex2TCoords_erase(array<S3DVertex2TCoords>* arr,u32 idx)
{
	if (arr)
		arr->erase(idx);
}

// do not delete this pointer
extern "C" S3DVertex2TCoords* IrrCore_Array_S3DVertex2TCoords_getLast(array<S3DVertex2TCoords>* arr)
{
	if (arr)
		return &arr->getLast();
	else
		return 0;
}

// do not delete this pointer
extern "C" S3DVertex2TCoords* IrrCore_Array_S3DVertex2TCoords_elementAt(array<S3DVertex2TCoords>* arr,u32 idx)
{
	if (arr)
		return &(*arr)[idx];
	else
		return 0;
}

extern "C" void IrrCore_Array_S3DVertex2TCoords_insert(array<S3DVertex2TCoords>* arr,S3DVertex2TCoords* element,u32 idx=0)
{
	if (arr)
		arr->insert(*element,idx);
}

extern "C" void IrrCore_Array_S3DVertex2TCoords_Eq(array<S3DVertex2TCoords>* arr,array<S3DVertex2TCoords>* other)
{
	if (arr)
		*arr=*other;
}

extern "C" void IrrCore_Array_S3DVertex2TCoords_push_back(array<S3DVertex2TCoords>* arr,S3DVertex2TCoords* element)
{
	if (arr)
		arr->push_back(*element);
}

extern "C" void IrrCore_Array_S3DVertex2TCoords_push_front(array<S3DVertex2TCoords>* arr,S3DVertex2TCoords* element)
{
	if (arr)
		arr->push_front(*element);
}

extern "C" void IrrCore_Array_S3DVertex2TCoords_reallocate(array<S3DVertex2TCoords>* arr,u32 new_size)
{
	if (arr)
		arr->reallocate(new_size);
}

extern "C" void IrrCore_Array_S3DVertex2TCoords_set_free_when_destroyed(array<S3DVertex2TCoords>* arr,bool f)
{
	if (arr)
		arr->set_free_when_destroyed(f);
}

extern "C" void IrrCore_Array_S3DVertex2TCoords_set_pointer(array<S3DVertex2TCoords>* arr,S3DVertex2TCoords newPointer[],u32 size)
{
	if (arr)
		arr->set_pointer(newPointer,size);
}

extern "C" void IrrCore_Array_S3DVertex2TCoords_set_sorted(array<S3DVertex2TCoords>* arr,bool bVal)
{
	if (arr)
		arr->set_sorted(bVal);
}

extern "C" void IrrCore_Array_S3DVertex2TCoords_set_used(array<S3DVertex2TCoords>* arr,bool bVal)
{
	if (arr)
		arr->set_used(bVal);
}

extern "C" u32 IrrCore_Array_S3DVertex2TCoords_size(array<S3DVertex2TCoords>* arr)
{
	if (arr)
		return arr->size();
	else
		return 0;
}

/*
extern "C" s32 IrrCore_Array_S3DVertex2TCoords_linear_reverse_search(array<S3DVertex2TCoords>* arr,S3DVertex2TCoords* find)
{
	if (arr)
		return arr->linear_reverse_search(*find);
	else
		return -1;
}

extern "C" s32 IrrCore_Array_S3DVertex2TCoords_linear_search(array<S3DVertex2TCoords>* arr,S3DVertex2TCoords* find)
{
	if (arr)
		return arr->linear_search(*find);
	else
		return -1;
}

extern "C" s32 IrrCore_Array_S3DVertex2TCoords_binary_search(array<S3DVertex2TCoords>* arr,S3DVertex2TCoords* find)
{
	if (arr)
		return arr->binary_search(*find);
	else
		return -1;
}



extern "C" s32 IrrCore_Array_S3DVertex2TCoords_binary_searchWithBounds(array<S3DVertex2TCoords>* arr,S3DVertex2TCoords* find,s32 left,s32 right)
{
	if (arr)
		return arr->binary_search(*find,left,right);
	else
		return -1;
}

extern "C" void IrrCore_Array_S3DVertex2TCoords_sort(array<S3DVertex2TCoords>* arr)
{
	if (arr)
		arr->sort();
}
*/


